=== debian/changelog ===
ros-noetic-mvsim (0.5.2-1buster) buster; urgency=high

  * FIX build farm errors in armhf builds
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Thu, 26 Jan 2023 23:00:00 -0000

ros-noetic-mvsim (0.5.1-1buster) buster; urgency=high

  * FIX: Stuck unit test runs in armhf build farms
  * Add demo with a large number of robots (100) in a simple setup
  * Support <for> loops in world definition files
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Wed, 25 Jan 2023 23:00:00 -0000

ros-noetic-mvsim (0.5.0-1buster) buster; urgency=high

  * New warehouse demo world file, including ros2 launch.
  * New feature: download models from remote servers.
  * Add 3D Lidar sensor.
  * Add support for headless simulations (mvsim launch --headless), suitable for running inside docker containers
  * New world element: vertical planes.
  * Add <for /> loops in XML world files
  * Support for formulas in XML files via  exprtk expressions
  * Fix naming convention; fix warnings
  * Move to clang-format-11
  * More consistent class member naming convention
  * Add simple Velodyne sensor DAE model
  * Add wget as build and runtime dep
  * PubSub system: Implemented the feature to notify subscribed clients about a new publisher for a topic
  * New 3D model: pioneer3
  * ROS: Add build and test dep python3-protobuf
  * Added unit tests
  * mvsim cli: add the --realtime-factor flag
  * more topic echo types
  * publish 2D lidar observations as custom protobuf msgs too
  * Add new protobuf msg type ObservationLidar2D.proto
  * add shutdown service
  * Fixed Python topic subscription and parsing
  * avoid potential crash during shutdown
  * FIX: Timelogger verbosity level is now copied from the main World object.
  * BUGFIX: Lidar sensors with ignore_parent_body=true should neither see the wheels
  * Tune PID parameters of examples
  * Refactoring and simplification of mutexes
  * cache GetServiceInfoRequest() calls (more efficient service calls in comms::Client)
  * factorize World services into its own .cpp file for clarity
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sun, 08 Jan 2023 23:00:00 -0000

ros-noetic-mvsim (0.4.3-1buster) buster; urgency=high

  * add names to gl objects (useful to debug)
  * configurable gui open timeout
  * GUI: new button Editor->Export 3Dscene file
  * Add a warning if using a physics timestep is incompatible with the sensor periods
  * FIX: more accurate simulation of timesteps; more mutexes
  * automatic determination of timestep; FIX bug: constant offset in simul time
  * fix FBO api for mrpt 2.5.6
  * fix build against mrpt 2.5.6; fix infinite loop while hitting quit button
  * refactor TCLAP objects to avoid global object initialization fiasco crashes
  * handle old and new versions of tf_geometry_msgs
  * mvsim cli new command: topic hz
  * Fix ROS2 obsolete header
  * fix build for u18.04
  * fix for older zmq versions
  * fix newest zmq deprecated warnings
  * FIX: DAE file error to load on newer version of assimp
  * provide cmake config types for gcc sanitizers
  * fix zmq API in bionic
  * avoid zmq_message_t ctor; more parallel threads for ZMQ
  * make the get_pose() service to answer immediately without needing to acquire the main simulation mutex
  * fix escaping
  * more portable makefile comparison for libbox2d version
  * d/rules: auto detection of system libbox2d version
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sun, 13 Nov 2022 23:00:00 -0000

ros-noetic-mvsim (0.4.2-1buster) buster; urgency=high

  * Disable Python wrappers for python <3.8
  * Honor DESTDIR when building and installing
  * Honor cli-provided PYTHON_INSTALL_DIRECTORY via cmake flags
  * Fix protobuf-generated broken Python3 imports (using protoletariat)
  * Add new WorldElement type: pointcloud
  * Add Python3 example for teleop twist
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Tue, 18 Oct 2022 22:00:00 -0000

ros-noetic-mvsim (0.4.1-1buster) buster; urgency=high

  * Add more documentation, demo files, and screenshots
  * Support animations from keyframe list for blocks and vehicles
  * Refactor common xml params in Simulable interface
  * Support PARENT_NAME usage in sensor definition files; add "<publish>" tags to tutorial sensors
  * 2D lidar sensor: new XML parameter maxRange
  * change threshold to decimate sensors preview subwindows
  * BUGFIX: Uninitialized quaternion in rviz marker (Closes #14 <https://github.com/MRPT/mvsim/issues/14>)
  * Allow expressions in include tags
  * Expose more lidar params in its XML
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Wed, 12 Oct 2022 22:00:00 -0000

ros-noetic-mvsim (0.4.0-1buster) buster; urgency=high

  * Major new release with tons of new features.
  * New sensors: RGB, depth, RGB+D cameras
  * Support for ROS1 and ROS2.
  * Sensors now can have 3D models.
  * New GUI controls to customize visualization.
  * New 3 and 4 wheels differential kinematic models.
  * Allow "include"s in XML files.
  * Add 3D Jackal robot model.
  * ROS nodes: publishers in parallel thread
  * mvsim-cli new flag to enable full profiling
  * Use new nanogui feature to limit GUI refresh rate
  * Fix running faster than real-time
  * More consistent timestamping of simulated sensors
  * mvsim now shows program version info
  * get_pose() service now also gets twist
  * Fix elevation maps
  * pybind11 per-version directory
  * Remove trailing '/' in tf frame names for consistency with modern conventions.
  * Rename COPYING -> LICENSE
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Mon, 26 Sep 2022 22:00:00 -0000

ros-noetic-mvsim (0.3.2-1buster) buster; urgency=high

  * Install models/ subdirectory too
  * Changes towards building for both ros1 & ros2

