## ros-noetic-mvsim 0.8.1

=== docs/requirements.txt ===
sphinx>=4.3.0
sphinx_rtd_theme>=0.5.1
sphinx_design
sphinxcontrib-bibtex
